/*-----------------------------------------------------------------------------
  sem.dat  aisamե

    쥳ɷ

        location  size       contents           key
        --------  ----   ------------------   ------
        0   6    7     쥳              0
           7       1     0x20
        8  67   60     Ф [ + 0x20 ]       1

	xxxxxxx x xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx
	0123456 7 8901234567890123456789012345678901234567
	            1         2         3         4

-----------------------------------------------------------------------------*/

#include "aisystem.h"
#include <string.h>

//#define DEBUG     1

#define REC_SIZE 68

//-----------------------------------------------------------------------------
int main (int argc, char *argv[]) {

  aiDes_t    des;
  char       buf[4096], rec[REC_SIZE], lines[20];
  FILE      *inpf, *p_file;

  struct  aiStat   stat;
  struct  stat     sbuf;

  int     comp=0, code=0, rc=0, i;

  if (argc != 3) {
    fprintf(stderr, "usage: %s ϥե̾(sem.dat) ե̾\n",
	    argv[0]);
    exit(-1);
  }

  if ((inpf = fopen(argv[1], "r")) == NULL) {
    fprintf(stderr, ";;; ERROR: can't open '%s'\n", argv[1]);
    exit(-1);
  }

  // 켭ιԿ
  sprintf(buf, "wc -l %s", argv[1]);

  if (! (p_file = popen(buf,"r")))
    strcpy(lines, "?");
  else {
    fgets (buf, 80 ,p_file);
    i = atoi(buf);
    sprintf(lines, "%d", i);
    pclose (p_file );
  }

  fprintf(stderr, "\n;;; creating: 켭 '%s'  %s lines\n", argv[1], lines);

  stat.length                      = REC_SIZE;
  stat.var_flag                    =  0;
  stat.comp_flag                   =  comp;
  stat.code_flag                   =  code;
  stat.key_num                     =  2;

  stat.key_inf[0].uniq_flag        =  1;
  stat.key_inf[0].fld_num          =  1;
  stat.key_inf[0].fld_inf[0].type  = AI_STRG;
  stat.key_inf[0].fld_inf[0].length=  7;
  stat.key_inf[0].fld_inf[0].offset=  0;

  stat.key_inf[1].uniq_flag        =  0;
  stat.key_inf[1].fld_num          =  1;
  stat.key_inf[1].fld_inf[0].type  = AI_STRG;
  stat.key_inf[1].fld_inf[0].length= 60;
  stat.key_inf[1].fld_inf[0].offset=  8;


  if (aiMkIsam(argv[2],&stat) == AI_ERR) {
    fprintf(stderr,";;; ERROR: aiMkIsam , aistatus [%d]\n",aistatus);
    exit(-1);
  }

  if ((des=aiOpnIsam(argv[2],AI_RW)) == NULL)  {
    fprintf(stderr,";;; ERROR: aiOpnIsam , aistatus [%d]\n",aistatus);
    exit(-1);
  }

  while (fgets(buf, 4095, inpf) != NULL) {
    buf[strlen(buf)-1] = 0;
    f_edit_rec(buf, rec);
    rc++;
    if (aiAddRec(des, rec) == AI_ERR)  {
      fprintf(stderr,";;; ERROR: aiAddRec , aistatus [%d]\n",aistatus);
      exit(-1);
    }
  }

  if (aiClsIsam(des) == AI_ERR) {
    fprintf(stderr,";;; ERROR: aiClsIsam , aistatus [%d]\n",aistatus);
    exit(-1);
  }

  fprintf(stderr,"\n;;; created %d records\n\n", rc);

  fclose(inpf);
}
//-----------------------------------------------------------------------------
int f_edit_rec (char *buf, char *rec) {

  char *p1;

  memset(rec, 0x20, REC_SIZE);

  memcpy(rec, buf, 7); // 쥳

  if (! (p1 = strchr(buf+8, '\t'))) {
    fprintf(stderr,";;; ERROR: invalid record format\n\n%s\n\n", buf);
    exit(-1);
  }
    
  *p1 = 0;

  strcpy(rec+8, buf+8);
  *(rec + (p1 - buf)) = 0x20;

#ifdef DEBUG
  {
    char tmp[61];

    memcpy(tmp, rec+8, 60);
    tmp[60] = 0;
    printf("[%s]\n", tmp);
  }
#endif

  return 0;
}
//-----------------------------------------------------------------------------
